export declare type MatchFunction = (value, ...extra) => any;
export interface ConstructingPattern {
    (value: any, ...extra: any[]): any;
    when?(pattern: any, valueOrFunction: any): this;
    default?(valueOrFunction?: any): MatchFunction;
    match?: MatchFunction;
    close?(): MatchFunction;
}
export interface Pattern extends ConstructingPattern {
    when(pattern: any, valueOrFunction: any): this;
    default(valueOrFunction?: any): MatchFunction;
    match: MatchFunction;
    close(): MatchFunction;
}
export declare function pattern(): Pattern;
export declare function match(value: any, patternBuilder: (Pattern) => void): any;
export declare const _: () => boolean;
export declare const some: (value: any) => boolean;
export declare const none: (value: any) => boolean;
export declare const either: (...patterns: any[]) => (value: any) => boolean;
export declare const range: (start: number, end: number) => (value: any) => boolean;
export declare const lt: (number: number) => (value: any) => boolean;
export declare const lte: (number: number) => (value: any) => boolean;
export declare const gt: (number: number) => (value: any) => boolean;
export declare const gte: (number: number) => (value: any) => boolean;
